import os
import sys
import licensing


class KantreeEncryptedModuleLoader(object):
    def find_module(self, fullname, path=None):
        self.fullname = fullname
        self.is_package = None
        if not path:
            return None
        basepath = os.path.join(os.path.join(*path), fullname.split('.')[-1])
        self.filename = basepath + '.pyx'
        if os.path.isfile(self.filename):
            return self
        self.filename = os.path.join(basepath, '__init__.pyx')
        if os.path.isfile(self.filename):
            self.is_package = basepath
            return self
        return None

    def __call__(self, *args, **kwargs):
        self.load_module(self.fullname)

    def load_module(self, fullname):
        if fullname in sys.modules:
            return sys.modules[fullname]
        return licensing.load(fullname, self.filename, self.is_package)


sys.meta_path.append(KantreeEncryptedModuleLoader())
