'use strict';

angular.module('common').run([
  'fileProviders', 'translation', 'config', 'baseUrl',
  function(fileProviders, translation, config, baseUrl) {
    $('<script type="text/javascript" src="https://js.live.net/v7.2/OneDrive.js"></script>').appendTo('head');

    fileProviders.push(() => [{
      label: translation._('Attach from OneDrive'),
      execute: [
        'finishCallback', (finishCallback) => {
          OneDrive.open({
            clientId: config.office365_client_id,
            action: "share",
            multiSelect: true,
            advanced: {
              redirectUri: baseUrl.absolute('/login/office365/filepicker')
            },
            success: (resp) => {
              finishCallback(resp.value.map((file) => {
                return {
                  name: file.name,
                  url: file.webUrl || file['@microsoft.graph.downloadUrl'],
                  mimetype: 'file' in file ? (file.file['mimeType'] || null) : null
                };
              }));
            }
          });
        }
      ]
    }]);
  }
]);
