'use strict';

export const mentionSpec = {
  inline: true,
  group: 'inline',
  draggable: false,
  attrs: {
    username: {}
  },
  toDOM: function(node) {
    return ['span', {
      'mention-username': node.attrs.username,
      class: 'mention-node'
    }, '@' + node.attrs.username];
  },
  parseDOM: [{
    tag: 'span[mention-username]',
    getAttrs: function(dom) {
      let attrs = {
        username: dom.getAttribute('mention-username')
      };
      let mentions = this.schema.data.mentions;
      if (Array.isArray(mentions) && mentions.find(m => m.username === attrs.username)) {
        return attrs;
      }
    }
  }]
};